#include <SoftwareSerial.h>
#include <Wire.h>
#include <OneWire.h>
#include <BMP085.h>
byte _d18x2x2Addr[8]={0x28, 0xFF, 0xEA, 0x3D, 0x73, 0x16, 0x5, 0x88}; //Датчик Куба

SoftwareSerial Serial100(12, 11);

BMP085  _bmp085 = BMP085();
long _bmp085P = 0;

byte _d18x2x1Addr[8]={0x28, 0xFF, 0xF8, 0xE6, 0x71, 0x16, 0x4, 0xF3}; //Датчик Колонны

byte _d18x2x3Addr[8]={0x28, 0xFF, 0xC1, 0x6D, 0x54, 0x16, 0x4, 0x68}; //Датчик Аварии

OneWire  _ow2(2);
int _AvlDFU0 = 0;
int _AvlDFU100 = 0;
bool _FreeLog1_IArr[2];
bool _FreeLog1_Q1_StArr[] = {0, 1};
bool _FreeLog2_IArr[3];
bool _FreeLog2_Q1_StArr[] = {1, 0, 0};
bool _FreeLog2_Q2_StArr[] = {1, 1, 0};
int _PWDC = 0;
bool _gtv1 = 1;
float _gtv6 = 777;
float _gtv7 = 777;
int _gtv11 = 0;
bool _gtv12 = 0;
int _gtv2 = 0;
bool _gtv3 = 0;
bool _gtv4 = 0;
int _gtv8 = 110;
float _gtv9;
String _gtv13;
float _gtv14;
float _gtv15;
unsigned long _bmp0851Tti = 0UL;
bool _gen4I = 0;
bool _gen4O = 0;
unsigned long _gen4P = 0UL;
bool _gen5I = 0;
bool _gen5O = 0;
unsigned long _gen5P = 0UL;
String _RVFU1Data;
bool _RVFU1Reset = 1;
String _GSFS6 = "0";
String _GSFS5 = "0";
String _GSFS3 = "0";
String _GSFS2 = "0";
String _GSFS1 = "0";
bool _trgs1 = 0;
String _GSFS9 = "0";
String _GSFS10 = "0";
String _RVFU2Data;
bool _RVFU2Reset = 1;
bool _swi2;
unsigned long _stou2 = 0UL;
String _swi4;
bool _swi3;
unsigned long _d18x2x2Tti = 0UL;
float _d18x2x2O = 0.00;
unsigned long _d18x2x1Tti = 0UL;
float _d18x2x1O = 0.00;
bool _trgs2 = 0;
String _swi7;
bool _pzs2OES = 0;
int _FSFS3IO = 0;
bool _gen3I = 0;
bool _gen3O = 0;
unsigned long _gen3P = 0UL;
bool _swi1;
int _FSFS9IO = 0;
int _FSFS6IO = 0;
bool _FSFS6CO = 0;
bool _FreeLog1_Q1 = 0;
bool _tim1I = 0;
bool _tim1O = 0;
unsigned long _tim1P = 0UL;
unsigned long _d18x2x3Tti = 0UL;
float _d18x2x3O = 0.00;
bool _swi6;
bool _swi5;
bool _gen1I = 0;
bool _gen1O = 0;
unsigned long _gen1P = 0UL;
unsigned long _stou1 = 0UL;
bool _FreeLog2_Q1 = 0;
bool _FreeLog2_Q2 = 0;
int _FSFS1IO = 0;
int _FSFS2IO = 0;
bool _FSFS2CO = 0;
int _FSFS5IO = 0;
bool _FSFS5CO = 0;
String _GSFS8 = "0";
String _GSFS11 = "0";
String _GSFS4 = "0";
int _FSFS8IO = 0;
bool _FSFS8CO = 0;
int _FSFS4IO = 0;
bool _FSFS4CO = 0;
bool _gen2I = 0;
bool _gen2O = 0;
unsigned long _gen2P = 0UL;
bool _trgrt2 = 0;
bool _trgrt2I = 0;
void setup()
{
Wire.begin();
delay(10);
TCCR2A = 0x00;
TCCR2B =  0x07;
TIMSK2=0x01;
TCNT2=100;
_bmp085.init();
Serial100.begin(9600);
Serial.begin(115200);
pinMode(7, OUTPUT);
pinMode(3, OUTPUT);
pinMode(5, OUTPUT);
pinMode(6, OUTPUT);
pinMode(8, OUTPUT);

_stou1 = millis();
_stou2 = millis();
}
void loop()
{_PWDC = 0;
if (_AvlDFU0){_AvlDFU0=0;} else{if (Serial.available()) {_AvlDFU0=1;  _readByteFromUART((Serial.read()),0);}}if (_AvlDFU100){_AvlDFU100=0;} else{if (Serial100.available()) {_AvlDFU100=1;  _readByteFromUART((Serial100.read()),100);}}if(_isTimer(_bmp0851Tti, 5000)) {
_bmp0851Tti = millis(); 
_bmp085.getPressure(&_bmp085P);
}




if(_trgs2)
{_swi7=_RVFU1Data;}
else
{_swi7=_RVFU2Data;}
if(_AvlDFU0) _trgs2 = 1;
if(_AvlDFU100) _trgs2 = 0;
if(( (_AvlDFU100) || (_AvlDFU0) )) {_tim1O = 1; _tim1I = 1;} else { if(_tim1I) {_tim1I = 0; _tim1P = millis();} else { if (_tim1O) {if ( _isTimer(_tim1P, 5000)) _tim1O = 0;}}}
if (!(_tim1O)) { if (_trgrt2I) { _trgrt2 = 0;} else {_trgrt2 = 1; _trgrt2I = 1;} } else {_trgrt2 = 0; _trgrt2I = 0;}; 
 if (_gtv1){if(!_RVFU2Reset){_RVFU2Data = String(""); _RVFU2Reset =1;}} else {_RVFU2Reset =0;}
_gtv13 = _swi7;
if (_gtv1){if(!_RVFU1Reset){_RVFU1Data = String(""); _RVFU1Reset =1;}} else {_RVFU1Reset =0;}
_gtv1 = _trgrt2;
_GSFS2 = (_gtv13).substring((_FSFS5IO), (_FSFS3IO));
_FSFS5IO = ((_gtv13).indexOf(String("#")));
_FSFS5CO = _FSFS5IO >-1 ;
_GSFS3 = (_GSFS2).substring(1);
if (_FSFS5CO) {
_gtv2 = (int((_stringToFloat(_GSFS3))));
}
_FSFS3IO = ((_gtv13).indexOf(String("!")));
_GSFS5 = (_gtv13).substring((_FSFS2IO), (_FSFS1IO));
_FSFS2IO = ((_gtv13).indexOf(String("@")));
_FSFS2CO = _FSFS2IO >-1 ;
_GSFS6 = (_GSFS5).substring(1);
if (_FSFS2CO) {
_gtv8 = (int((_stringToFloat(_GSFS6))));
}
_FSFS1IO = ((_gtv13).indexOf(String("!")));
_GSFS10 = (_gtv13).substring((_FSFS4IO), (_FSFS6IO));
_FSFS4IO = ((_gtv13).indexOf(String("$")));
_FSFS4CO = _FSFS4IO >-1 ;
_GSFS11 = (_GSFS10).substring(1);
if (_FSFS4CO) {
_gtv11 = (int((_stringToFloat(_GSFS11))));
}
_FSFS6IO = ((_gtv13).indexOf(String("&")));
_FSFS6CO = _FSFS6IO >-1 ;
_GSFS4 = (_gtv13).substring((_FSFS6IO), (_FSFS8IO));
_GSFS8 = (_GSFS4).substring(1);
if (_FSFS6CO) {
_gtv6 = (_stringToFloat(_GSFS8));
}
_FSFS8IO = ((_gtv13).indexOf(String("*")));
_FSFS8CO = _FSFS8IO >-1 ;
_GSFS9 = (_gtv13).substring((_FSFS8IO), (_FSFS9IO));
_GSFS1 = (_GSFS9).substring(1);
if (_FSFS8CO) {
_gtv7 = (_stringToFloat(_GSFS1));
}
_FSFS9IO = ((_gtv13).indexOf(String("%")));

if(_isTimer(_d18x2x1Tti, 5000)) {
_d18x2x1Tti = millis(); 
_d18x2x1O=  _readDS18_ow2(_d18x2x1Addr, 0);}
if(_isTimer(_d18x2x2Tti, 5000)) {
_d18x2x2Tti = millis(); 
_d18x2x2O=  _readDS18_ow2(_d18x2x2Addr, 0);}
if(_isTimer(_d18x2x3Tti, 5000)) {
_d18x2x3Tti = millis(); 
_d18x2x3O=  _readDS18_ow2(_d18x2x3Addr, 0);}
if(_gtv12)
{_swi4=String("1");}
else
{_swi4=String("0");}
_gtv9 = (_d18x2x1O);
_gtv14 = (_d18x2x2O);
_gtv15 = (_d18x2x3O);
if (!(_gtv1)){ if (_isTimer(_stou2, 2000 )) {Serial.print(((((String("HomeSamogon.ru")) + (String("/4.0")))) + (String(",")) + (( _floatToStringWitRaz(_gtv9,1))) + (String(",")) + (( _floatToStringWitRaz((_bmp085P)/(133.3),1))) + (String(",")) + (( _floatToStringWitRaz(_gtv14,1))) + (String(",")) + ((String(_gtv11, DEC))) + (String(",")) + (_swi4) + (String(",")) + (( _floatToStringWitRaz(_gtv6,1))) + (String(",")) + (( _floatToStringWitRaz(_gtv7,1))) + (String(",")) + ((String(_gtv2, DEC))) + (String(",")) + ((String(_gtv8, DEC))) + (String(",")) + (( _floatToStringWitRaz((((_stringToFloat(( _floatToStringWitRaz(_gtv14,1)))))+(3.14))*(((_stringToFloat(( _floatToStringWitRaz(_gtv9,1)))))+((_stringToFloat(( _floatToStringWitRaz((_bmp085P)/(133.3),1)))))),1))) + (String(",")) + (( _floatToStringWitRaz(_gtv15,1))) + (String(",")) + (String("0")) + (String(",")) + (String("0")) + (String(",")) + (String("%")) + (String(",")))); _stou2 = millis();}} else {_stou2 = millis();}
if (!(_gtv1)){ if (_isTimer(_stou1, 2000 )) {Serial100.print(((((String("HomeSamogon.ru")) + (String("/4.0")))) + (String(",")) + (( _floatToStringWitRaz(_gtv9,1))) + (String(",")) + (( _floatToStringWitRaz((_bmp085P)/(133.3),1))) + (String(",")) + (( _floatToStringWitRaz(_gtv14,1))) + (String(",")) + ((String(_gtv11, DEC))) + (String(",")) + (_swi4) + (String(",")) + (( _floatToStringWitRaz(_gtv6,1))) + (String(",")) + (( _floatToStringWitRaz(_gtv7,1))) + (String(",")) + ((String(_gtv2, DEC))) + (String(",")) + ((String(_gtv8, DEC))) + (String(",")) + (( _floatToStringWitRaz((((_stringToFloat(( _floatToStringWitRaz(_gtv14,1)))))+(3.14))*(((_stringToFloat(( _floatToStringWitRaz(_gtv9,1)))))+((_stringToFloat(( _floatToStringWitRaz((_bmp085P)/(133.3),1)))))),1))) + (String(",")) + (( _floatToStringWitRaz(_gtv15,1))) + (String(",")) + (String("0")) + (String(",")) + (String("0")) + (String(",")) + (String("%")) + (String(",")))); _stou1 = millis();}} else {_stou1 = millis();}

if (!(( ((_gtv2) < (50)) || ((_gtv2) >= (972)) ))) {if (! _gen2I) { _gen2I = 1; _gen2O = 1; _gen2P =  millis(); } } else { _gen2I = 0 ;  _gen2O= 0;  } if (_gen2I ) { if (_gen2O) { if ( _isTimer( _gen2P , (map((_gtv2), (50), (972), (0), (8000))) )) { _gen2P = millis(); _gen2O = 0; } } else  { if ( _isTimer( _gen2P , (8000)-((map((_gtv2), (50), (972), (0), (8000)))) )) {  _gen2P = millis(); _gen2O = 1;  } } }
if(( ((_gtv2) < (50)) || ((_gtv2) >= (972)) ))
{_swi2=_FreeLog1_Q1;}
else
{_swi2=_gen2O;}
_FreeLog1_IArr[0] = (_gtv2) < (50);
_FreeLog1_IArr[1] = (_gtv2) >= (972);
_FreeLog1_Q1 = _checkFreeLogicBlockOutput(_FreeLog1_IArr, 2, _FreeLog1_Q1_StArr, 2); 
_gtv3 = _swi2;
_gtv4 = ( ((_gtv2) < (50)) || ((_gtv2) >= (972)) );

if(_gtv4)
{_swi1=_gtv3;}
else
{_swi1=( (!(_trgs1)) && (_gtv3) );}
if((_gtv9) >= ((_gtv7)-((_gtv7)-(_gtv6)))) _trgs1 = 1;
if((_gtv9) < (_gtv7)) _trgs1 = 0;
_gtv12 = !(_trgs1);
digitalWrite(8, !(_swi1));
digitalWrite(7, _swi1);

if (_FreeLog2_Q1) {if (! _gen3I) { _gen3I = 1; _gen3O = 1; _gen3P =  millis(); } } else { _gen3I = 0 ;  _gen3O= 0;  } if (_gen3I ) { if (_gen3O) { if ( _isTimer( _gen3P , 200 )) { _gen3P = millis(); _gen3O = 0; } } else  { if ( _isTimer( _gen3P , 400 )) {  _gen3P = millis(); _gen3O = 1;  } } }
if (_FreeLog2_Q2) {if (! _gen5I) { _gen5I = 1; _gen5O = 1; _gen5P =  millis(); } } else { _gen5I = 0 ;  _gen5O= 0;  } if (_gen5I ) { if (_gen5O) { if ( _isTimer( _gen5P , 300 )) { _gen5P = millis(); _gen5O = 0; } } else  { if ( _isTimer( _gen5P , 300 )) {  _gen5P = millis(); _gen5O = 1;  } } }
if(( (( (_gen3O) || (_gen5O) )) || ((_gtv15) > (65.00)) ))
{if((!_pzs2OES)){ tone(4, 800); _pzs2OES =1;}} else {if(_pzs2OES){noTone(4); _pzs2OES =0;  }}
_FreeLog2_IArr[0] = (_gtv14) >= (_gtv8);
_FreeLog2_IArr[1] = (_gtv14) >= ((_gtv8)+(1));
_FreeLog2_IArr[2] = (_gtv8) == (110);
_FreeLog2_Q1 = _checkFreeLogicBlockOutput(_FreeLog2_IArr, 3, _FreeLog2_Q1_StArr, 3); 
_FreeLog2_Q2 = _checkFreeLogicBlockOutput(_FreeLog2_IArr, 3, _FreeLog2_Q2_StArr, 3); 

if(_gtv4)
{_swi5=(_gtv2) < (50);}
else
{_swi5=_gen4O;}
if (( (!(_gtv12)) && ((_gtv11) == (1)) )) {if (! _gen4I) { _gen4I = 1; _gen4O = 1; _gen4P =  millis(); } } else { _gen4I = 0 ;  _gen4O= 0;  } if (_gen4I ) { if (_gen4O) { if ( _isTimer( _gen4P , 1600 )) { _gen4P = millis(); _gen4O = 0; } } else  { if ( _isTimer( _gen4P , 400 )) {  _gen4P = millis(); _gen4O = 1;  } } }
if (( (_gtv12) && ((_gtv11) == (1)) )) {if (! _gen1I) { _gen1I = 1; _gen1O = 1; _gen1P =  millis(); } } else { _gen1I = 0 ;  _gen1O= 0;  } if (_gen1I ) { if (_gen1O) { if ( _isTimer( _gen1P , 1600 )) { _gen1P = millis(); _gen1O = 0; } } else  { if ( _isTimer( _gen1P , 400 )) {  _gen1P = millis(); _gen1O = 1;  } } }
if(_gtv4)
{_swi3=(_gtv2) >= (972);}
else
{_swi3=_gen1O;}
if(_gtv4)
{_swi6=0;}
else
{_swi6=(_gtv11) == (0);}
digitalWrite(3, _swi5);
digitalWrite(5, _swi3);
digitalWrite(6, _swi6);




}
float  _stringToFloat(String value)
  {
 
  return value.toFloat() ;
  }
String  _floatToStringWitRaz(float value, int raz)
{
 
  return String(value,raz);
}
bool _isTimer(unsigned long startTime, unsigned long period )
  {
  unsigned long currentTime;
currentTime = millis();
if (currentTime>= startTime) {return (currentTime>=(startTime + period));} else {return (currentTime >=(4294967295-startTime+period));}
  }

ISR(TIMER2_OVF_vect)
{ TCNT2=100;
if(_PWDC >= 1000){asm volatile ("jmp 0x0000");}else{_PWDC = _PWDC+1;};
}
void _readByteFromUART(byte data,int port)
{
if (port==0){_RVFU1Data += char(data);}
if (port==100){_RVFU2Data += char(data);}
}
float _convertDS18x2xData(byte type_s, byte data[12])
{
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) 
  {
  raw = raw << 3; 
  if (data[7] == 0x10) { raw = (raw & 0xFFF0) + 12 - data[6]; }
  }
else 
  {
   byte cfg = (data[4] & 0x60);
   if (cfg == 0x00) raw = raw & ~7;   else if (cfg == 0x20) raw = raw & ~3;  else if (cfg == 0x40) raw = raw & ~1;
  }
return  (float)raw / 16.0;
}
float _readDS18_ow2(byte addr[8], byte type_s)
{  byte data[12];
byte i;
_ow2.reset();
_ow2.select(addr);
_ow2.write(0xBE);
for ( i = 0; i < 9; i++) {
 data[i] = _ow2.read();}
_ow2.reset();
_ow2.select(addr);
_ow2.write(0x44, 1);
return _convertDS18x2xData(type_s, data);}bool _checkFreeLogicBlockOutput(bool inArray[], int inArraySize, bool stArray[], int stArraySize)
{ int inIndex = 0;
  bool result = 1;
  for (int i = 0; i < stArraySize; i = i + 1)
  {
   if (!(inArray[inIndex] == stArray[i])) { result = 0;}
   inIndex ++;
   if (inIndex == inArraySize)
     {
     if (result) { return 1;} else {result = 1;}
     inIndex = 0;
     }
  }
  return 0;
}
